#include "UDP.h"

#include "utility/w5500.h"
#include "utility/socket.h"

void sendUDP_tick(SOCKET s, ConnectionStatusSimple &status)
{
  switch (status)
  {
  case CONNECT_START:
    w5500.execCmdSn(s, Sock_SEND);
    status = CONNECT_CONNECTING;
    break;

  case CONNECT_CONNECTING:
    if ((w5500.readSnIR(s) & SnIR::SEND_OK) != SnIR::SEND_OK)
    {
      if (w5500.readSnIR(s) & SnIR::TIMEOUT)
      {
        /* +2008.01 [bj]: clear interrupt */
        w5500.writeSnIR(s, (SnIR::SEND_OK | SnIR::TIMEOUT));
        status = CONNECT_FAIL;
        break;
      }
      else
      {
        status = CONNECT_CONNECTING;
        break;
      }
    }
    else
    {
      status = CONNECT_SUCCESS;
      w5500.writeSnIR(s, SnIR::SEND_OK);
      break;
    }
    break;

  case CONNECT_FAIL:
    status = CONNECT_IDLE;
    break;
  case CONNECT_SUCCESS:
    status = CONNECT_IDLE;
    break;
  case CONNECT_IDLE:
    break;

  default:
    break;
  }
}

void EthernetMaketUDP::endPacketNonBlock()
{
  _status = CONNECT_START;
  sendUDP_tick(_sock, _status);
  return;
}

void EthernetMaketUDP::tick(){
  sendUDP_tick(_sock, _status);
}

ConnectionStatusSimple EthernetMaketUDP::getState() const{
  return _status;
}
